#include <iostream>

using namespace std;


int Count_Chunks(int cur_x, int cur_y, int cur_z, int max_x, int max_y, int max_z, int chunk_size){
  // how many chunks can we fit in the x direction?
  int x_chunks = (max_x-cur_x)/chunk_size;
  if(cur_x > 0)
    x_chunks++;
  if((max_x-cur_x)%chunk_size > 0)
    x_chunks++;
  // next, try the y direction
  int y_chunks = (max_y-cur_y)/chunk_size;
  if(cur_y > 0)
    y_chunks++;
  if((max_y - cur_y)%chunk_size > 0)
    y_chunks++;
  // finally, z
  int z_chunks = (max_z-cur_z)/chunk_size;
  if(cur_z > 0)
    z_chunks++;
  if((max_z -cur_z) % chunk_size > 0)
    z_chunks++;
  // the total number of chunks is the product of the chunks in each direction
  return x_chunks*y_chunks*z_chunks;
}

int main(){
  int n, x, y,z;
  cin >> n >> x >> y >> z;
  int cur_case = 1;
  while(n > 0){
    
    int cur_min = x*y*z+1;
    int cur_max = 0;
    for(int i = 0; i < n; i++)
      if(i < x)
	for(int j = 0; j < n; j++)
	  if( j < y)
	    for(int k = 0; k < n; k++)
	      if(k < z){
		int total = Count_Chunks(i,j,k, x,y,z,n);
		if(total < cur_min)
		  cur_min = total;
		if(total > cur_max)
		  cur_max = total;
	      }

    cout << "Case " << cur_case << ": Min " << cur_min << ", Max " << cur_max << endl;
    cur_case++;
    cin >> n >> x >> y >> z;
  }
  return 0;
}
